      function besi0 (x)
c april 1977 version.  w. fullerton, c3, los alamos scientific lab.
      dimension bi0cs(12)
      external  besi0e, csevl, inits, r1mach
c
c series for bi0        on the interval  0.          to  9.00000d+00
c                                        with weighted error   2.46e-18
c                                         log weighted error  17.61
c                               significant figures required  17.90
c                                    decimal places required  18.15
c
      data bi0 cs( 1) /   -.0766054725 2839144951e0 /
      data bi0 cs( 2) /   1.9273379539 93808270e0 /
      data bi0 cs( 3) /    .2282644586 920301339e0 /
      data bi0 cs( 4) /    .0130489146 6707290428e0 /
      data bi0 cs( 5) /    .0004344270 9008164874e0 /
      data bi0 cs( 6) /    .0000094226 5768600193e0 /
      data bi0 cs( 7) /    .0000001434 0062895106e0 /
      data bi0 cs( 8) /    .0000000016 1384906966e0 /
      data bi0 cs( 9) /    .0000000000 1396650044e0 /
      data bi0 cs(10) /    .0000000000 0009579451e0 /
      data bi0 cs(11) /    .0000000000 0000053339e0 /
      data bi0 cs(12) /    .0000000000 0000000245e0 /
c
      data nti0, xsml, xmax / 0, 0., 0. /
c
      if (nti0.ne.0) go to 10
      nti0 = inits (bi0cs, 12, 0.1*r1mach(3))
      xsml = sqrt (4.0*r1mach(3))
      xmax = alog (r1mach(2))
c
 10   y = abs(x)
      if (y.gt.3.0) go to 20
c
      besi0 = 1.0
      if (y.gt.xsml) besi0 = 2.75 + csevl (y*y/4.5-1.0, bi0cs, nti0)
      return
c
 20   if (y.gt.xmax) call seteru (34hbesi0   abs(x) so big i0 overflows,
     1  34, 1, 2)
c
      besi0 = exp(y) * besi0e(x)
c
      return
      end
